/**************************************************************************
**  (c) Copyright 1997, Andromeda Technology & Automation
***************************************************************************
** MODULE INFORMATION *
***********************
**      FILE NAME      : superstring.cpp
**      SYSTEM NAME    : Andromeda X-Windows Encapsulation
**      VERSION NUMBER : $Revision: 1.5 $
**
**  DESCRIPTION      :  SuperString class implementation.
**
**  EXPORTED OBJECTS : 
**  LOCAL    OBJECTS : 
**  MODULES  USED    :
***************************************************************************
**  ADMINISTRATIVE INFORMATION *
********************************
**      ORIGINAL AUTHOR : Arjen Baart - arjen@andromeda.nl
**      CREATION DATE   : Jun 10, 2020
**      LAST UPDATE     : Jun 10, 2020
**      MODIFICATIONS   : 
**************************************************************************/

#include <stdio.h>
#include <ctype.h>
#include "String.h"

// Addition operators

SuperString operator+(const SuperString& sx, const SuperString& sy)
{
   SuperString sum;

   sum = sx;
   sum._ss.insert(sum._ss.end(), sy._ss.begin(), sy._ss.end());

   return sum;
}

SuperString operator+(const SuperString& ss, const String& s)
{
   SuperString SS(ss);

   SS._ss.push_back(s);

   return SS;
}

SuperString operator+(const String& s, const SuperString& ss)
{
   SuperString sum;

   sum = ss;
   sum._ss.insert(sum._ss.begin(), s);

   return sum;
}

SuperString& SuperString::operator+=(const String& x)
{
   _ss.push_back(x);

   return *this;
}

String SuperString::join(const String &separator)
{
   String joined;

   if (_ss.size() != 0)
   {
      joined = _ss[0];
      for (unsigned i = 1; i < _ss.size(); i++)
      {
         joined += separator + _ss[i];
      }
   }

   return joined;
}
