/*******************************************************
 *  Unit test for the date class
 *
 * test the date parser that converts String to date
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   date   d0;
   String the_date;


   the_date = "20120208";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "2012-02-08";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "2012 02 08";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "08-02-2012";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "02/08/2012";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "Feb 8 2012";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "2012 Feb 8";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "8 FEB 2012";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "2012 8 feb";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "8 February 2012";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, 2012));

   the_date = "Sun Jun 16 13:02:56 CEST 2019";   // A UNIX date string
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(16, 6, 2019));

   the_date = "Wed Sep 09 16:40:03.634357 2020";   // A UNIX date string with fractional seconds
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(9, 9, 2020));

   //  Without a year: year = -1
   the_date = "8 February";
   d0 = date(the_date);
   std::cout << "String \"" << the_date << "\" converts to: \"" << d0 << "\"\n";
   assert(d0 == date(8, 2, -1));

   //  TODO: test for invalid dates and syntax errors

   return 0;
}

