/*******************************************************
 *  Unit test for the hour class
 *
 * test hour add and subtract expressions
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   hour   h0(14, 22, 45);
   hour   period0(11, 45, 30);

   hour h2;
   h2 = h0 + period0;

   std::cout << h0 << " + " << period0 << " = " << h2 << "\n";
   assert(h2 == hour(26, 8, 15));

   std::cout << h0 << " += " << period0 << " = ";
   h0 += period0;
   std::cout << h0 << "\n";
   assert(h0 == hour(26, 8, 15));

   // 11:05:30 - 1:20:40 =  9:44:50
   hour h1(11, 5, 30);
   hour period1(1, 20, 40);
   h2 = h1 - period1;

   std::cout << h1 << " - " << period1 << " = " << h2 << "\n";
   assert(h2 == hour(9, 44, 50));

   std::cout << h1 << " -= " << period1 << " = ";
   h1 -= period1;
   std::cout << h1 << "\n";
   std::cout.flush();
   assert(h1 == hour(9, 44, 50));

   // The increment operator

   hour h3(22, 59, 59);
   std::cout << h3 << "++ = ";
   h3++;
   std::cout << h3 << "\n";
   assert(h3 == hour(23, 0, 0));

   hour h4(22, 59, 59);
   std::cout << "++" << h4 << " = ";
   ++h4;
   std::cout << h4 << "\n";
   assert(h4 == hour(23, 0, 0));

   // The decrement operator

   hour h5(22, 0, 0);
   std::cout << h5 << "-- = ";
   h5--;
   std::cout << h5 << "\n";
   assert(h5 == hour(21, 59, 59));

   hour h6(22, 0, 0);
   std::cout << "--" << h6 << " = ";
   --h6;
   std::cout << h6 << "\n";
   assert(h6 == hour(21, 59, 59));

   // Adding an integer number of seconds

   hour   h7(14, 22, 45);
   long   s7 = 7000;
   hour   h8;

   h8 = h7 + s7;
   std::cout << h7 << " + " << s7 << " seconds = " << h8 << "\n";
   assert(h8 == hour(16, 19, 25));

   std::cout << h7 << " += " << s7 << " seconds = ";
   h7 += s7;
   std::cout << h7 << "\n";
   assert(h7 == hour(16, 19, 25));

   // Subtracting an integer number of seconds

   hour   h11(14, 22, 45);
   long   s11 = 7000;
   hour   h12;

   h12 = h11 - s11;
   std::cout << h11 << " - " << s11 << " seconds = " << h12 << "\n";
   assert(h12 == hour(12, 26, 05));

   std::cout << h11 << " -= " << s11 << " seconds = ";
   h11 -= s11;
   std::cout << h11 << "\n";
   assert(h11 == hour(12, 26, 05));

   return 0;
}

