/*******************************************************
 *  Unit test for the hour class
 *
 * test if the now() function returns the system date
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main(int argc, char *argv[])
{
   hour d0;

   if (argc >= 2)
   {
      hour one_second(0, 0, 1);
      String system_date(argv[1]);
      hour d1(system_date);
      if (argc == 3)
      {
         // Use UTC
         d0 = now(false);
      }
      else
      {
         // Use local time
         d0 = now();
      }
      std::cout << "Hour of now() = " << d0 << "\n";
      std::cout.flush();

      // Allow for 1 second delay
      assert(d0 == d1 || d0 == d1 + hour(0, 0, 1));
   }

   return 0;
}

