/*******************************************************
 *  Unit test for the String class
 *
 * test modification operations
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{

   // Upper and lower case conversion

   String s1 = "Abc-12.3dE";

   String s2 = s1.upper();
   std::cout << s1 << " converted to upper case is" << s2 << "\n";
   assert(s2 == "ABC-12.3DE");

   String s3 = s1.lower();
   std::cout << s1 << " converted to lower case is" << s3 << "\n";
   assert(s3 == "abc-12.3de");
   assert(s3.upper() == s2);

   // Escaping special characters

   String s4 = "\a\b\f\n\r\t\v\"'\\\xC0\x02";
   String s5 = s4.escape();
   std::cout << "Escaped sequence = " << s5 << "\n";
   assert (s5.unescape() == s4);


   return 0;
}

