/*******************************************************
 *  Unit test for the String class
 *
 * test regular expression operations
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // TODO: test regex constructors

   // A simple regular expression
   regex nr("[0-9]+");

   // Regular expression matching
   String s1 = "abcdef";
   String s2 = "abd123def";

   std::cout << "Regular expression matching.\n";
   assert((s1 == nr) == false);
   assert((s2 == nr) == true);

   assert((s1 != nr) == true);
   assert((s2 != nr) == false);

   // Select a substring with a regex

   String match;

   match = s2(nr);
   std::cout << "The matching part of \"" << s2 << "\" is \"" << match << "\"\n";
   assert(match == "123");

   // Test a regex with an error

   bool exception_caught = false;

   try
   {
      regex wrong_nr("[0-9+");
      std::cout << "No regex error detected.\n";
   }
   catch (RegexException rexc)
   {
      std::cout << "Regex exception: " << rexc.what() << "\n";
      exception_caught = true;
   }

   assert(exception_caught);

   return 0;
}

