/*******************************************************
 *  Unit test for the SuperString class
 *
 * test split and join of String and SuperString
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

void print_ss(SuperString ss)
{
   std::cout << "[";
   for (int i = 0; i < ~ss; i++)
   {
      if (i != 0)
         std::cout << ",";
      std::cout << "\"" << ss[i] << "\"";
   }
   std::cout << "]";
}

int main()
{
   String      s0("The_String_To_Split");
   SuperString ss0;

   ss0 = s0.split("_");

   std::cout << "The string " << s0 << " split on \"_\":\n";
   print_ss(ss0);
   std::cout << "\n";

   assert(ss0[0] == "The");
   assert(ss0[1] == "String");
   assert(ss0[2] == "To");
   assert(ss0[3] == "Split");

   String s1;

   s1 = ss0.join(" ");
   std::cout << "Joined with ' ': " << s1 << "\n";
   assert(s1 == "The String To Split");

   return 0;
}

