/*******************************************************
 *  Unit test for the SuperString class
 *
 * test basic SuperString operations
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

int main()
{
   // Default contructor: empty SuperString
   SuperString ss0;

   assert(~ss0 == 0);

   // The length of a string with the ~ operator
   String s1("abcde");
   SuperString ss1(s1);

   // check boolean opareations that check for empty strings

   if (ss0)
   {
      std::cout << " ss0 is not empty.\n";
   }
   else
   {
      std::cout << " ss0 is empty.\n";
   }
   if (!ss0)
   {
      std::cout << " ss0 is empty.\n";
   }
   else
   {
      std::cout << " ss0 is not empty.\n";
   }

   if (ss1)
   {
      std::cout << " ss1 is not empty.\n";
   }
   else
   {
      std::cout << " ss1 is empty.\n";
   }
   if (!ss1)
   {
      std::cout << " ss1 is empty.\n";
   }
   else
   {
      std::cout << " ss1 is not empty.\n";
   }

   int    length;
   SuperString  ss2(5);
   length = ~ss2;
   std::cout << "The length of ss2 is " << length << "\n";
   assert(length == 5);

   // test String access, also outside boundaries (e.g. -1, 666)

   String s2;
   s2 = ss1[0];
   std::cout << "First string of ss1 is \"" << s2 << "\"\n";
   assert(s2 == "abcde");

   // An out of bounds index throws an exception

   try
   {
      s2 = ss1[3];
      std::cout << "Fourth string of ss1 is \"" << s2 << "\"\n";
   }
   catch (std::out_of_range e)
   {
      std::cout << "SuperString exception: " << e.what() << "\n";
   }

   //  Fill up a SuperSting with some content.

   SuperString ss3(4);
   ss3[0] = "abc";
   ss3[1] = "def";
   ss3[3] = "xyz";

   for (int i = 0; i < ~ss3; i++)
   {
      std::cout << "ss3[" << i << "] = " << ss3[i] << "\n";
   }
   return 0;

}

