/*******************************************************
 *  Unit test for the SuperString class
 *
 * test relational operators
 ******************************************************
 *
 */

#include "String.h"
#include <assert.h>

void print_ss(SuperString ss)
{
   std::cout << "[";
   for (int i = 0; i < ~ss; i++)
   {
      if (i != 0)
         std::cout << ",";
      std::cout << "\"" << ss[i] << "\"";
   }
   std::cout << "]";
}

int main()
{
   String s1("abcdef");
   String s2("abcdef");
   String s3("vwuxyz");

   SuperString ss1(s1);
   SuperString ss2(s2);
   SuperString ss3(s3);

   print_ss(ss1);
   std::cout << " == ";
   print_ss(ss2);
   std::cout << " = " << (ss1 == ss2)  << "\n";
   assert((ss1 == ss2) == true);

   print_ss(ss1);
   std::cout << " == ";
   print_ss(ss3);
   std::cout << " = " << (ss1 == ss3)  << "\n";
   assert((ss1 == ss3) == false);

   print_ss(ss1);
   std::cout << " != ";
   print_ss(ss2);
   std::cout << " = " << (ss1 != ss2)  << "\n";
   assert((ss1 != ss2) == false);

   print_ss(ss1);
   std::cout << " != ";
   print_ss(ss3);
   std::cout << " = " << (ss1 != ss3)  << "\n";
   assert((ss1 != ss3) == true);

   print_ss(ss1);
   std::cout << " < ";
   print_ss(ss2);
   std::cout << " = " << (ss1 < ss2)  << "\n";
   assert((ss1 < ss2) == false);

   print_ss(ss1);
   std::cout << " < ";
   print_ss(ss3);
   std::cout << " = " << (ss1 < ss3)  << "\n";
   assert((ss1 < ss3) == true);

   print_ss(ss3);
   std::cout << " < ";
   print_ss(ss1);
   std::cout << " = " << (ss3 < ss1)  << "\n";
   assert((ss3 < ss1) == false);

   print_ss(ss1);
   std::cout << " > ";
   print_ss(ss2);
   std::cout << " = " << (ss1 > ss2)  << "\n";
   assert((ss1 > ss2) == false);

   print_ss(ss1);
   std::cout << " > ";
   print_ss(ss3);
   std::cout << " = " << (ss1 > ss3)  << "\n";
   assert((ss1 > ss3) == false);

   print_ss(ss3);
   std::cout << " > ";
   print_ss(ss1);
   std::cout << " = " << (ss3 > ss1)  << "\n";
   assert((ss3 > ss1) == true);

   print_ss(ss1);
   std::cout << " <= ";
   print_ss(ss2);
   std::cout << " = " << (ss1 <= ss2)  << "\n";
   assert((ss1 <= ss2) == true);

   print_ss(ss1);
   std::cout << " <= ";
   print_ss(ss3);
   std::cout << " = " << (ss1 <= ss3)  << "\n";
   assert((ss1 <= ss3) == true);

   print_ss(ss3);
   std::cout << " <= ";
   print_ss(ss1);
   std::cout << " = " << (ss3 <= ss1)  << "\n";
   assert((ss3 <= ss1) == false);

   print_ss(ss1);
   std::cout << " >= ";
   print_ss(ss2);
   std::cout << " = " << (ss1 >= ss2)  << "\n";
   assert((ss1 >= ss2) == true);

   print_ss(ss1);
   std::cout << " >= ";
   print_ss(ss3);
   std::cout << " = " << (ss1 >= ss3)  << "\n";
   assert((ss1 >= ss3) == false);

   print_ss(ss3);
   std::cout << " >= ";
   print_ss(ss1);
   std::cout << " = " << (ss3 >= ss1)  << "\n";
   assert((ss3 >= ss1) == true);


   return 0;
}

