/*******************************************************
 *  Unit test for the UTC class
 *
 * test UTC add and subtract expressions
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   date   d0(9, 6, 2019);
   hour   t0;
   UTC    period0(date(5, 3, 6), t0);

   UTC u0(d0, t0);
   UTC d1;
   UTC d2;
   d2 = u0 + period0;

   std::cout << u0 << " + " << period0 << " = " << d2 << "\n";
   assert(d2 == UTC(date(14, 9, 2025), t0));

   UTC    period1(date(30, 11, 3), t0);   // 3 years, 11 months and 30 days
   d2 = u0 + period1;
   std::cout << u0 << " + " << period1 << " = " << d2 << "\n";
   assert(d2 == UTC(date(8, 6, 2023), t0));

   d1 = UTC(date(22, 7, 2019), t0);
   std::cout << d1 << " += " << period1 << " = ";
   d1 += period1;
   std::cout << d1 << "\n";
   std::cout.flush();
   assert(d1 == UTC(date(22, 7, 2023), t0));

   // Calculate the number of seconds between 2 UTC objects.

   date d3(2, 2, 2020);
   hour h3(10, 0, 0);
   UTC  u3(d3, h3);
   date d4(4, 2, 2020);
   hour h4(20, 0, 0);
   UTC  u4(d4, h4);

   long l4 = u4 - u3;
   std::cout << "From " << u3 << " to " << u4 << " takes " << l4 << " seconds\n";
   assert(l4 == 208800);

   return 0;
}

