/*******************************************************
 *  Unit test for the UTC class
 *
 * test contrustor and assignment of UTC objects
 ******************************************************
 *
 */

#include "date.h"
#include <assert.h>

int main()
{
   // Default contructor: all zero
   UTC  u0;
   date d0;
   hour h0;

   d0 = date(u0);
   h0 = hour(u0);

   std::cout << "The default contructor makes a zero date:and time " << u0 << "\n";
   assert(d0.Day() == 0);
   assert(d0.Month() == 0);
   assert(d0.Year() == 0);
   assert(h0.Hour() == 0);
   assert(h0.Minute() == 0);
   assert(h0.Second() == 0);

   date d1(15, 9, 2002);
   hour h1(15, 23, 46);

   UTC  u1(d1, h1);

   std::cout << "Contructor with date = 15-9-2002, hour = 15:23:46: " << u1 << "\n";
   date d2(u1);
   hour h2(u1);

   assert(d2.Day() == 15);
   assert(d2.Month() == 9);
   assert(d2.Year() == 2002);
   assert(h2.Hour() == 15);
   assert(h2.Minute() == 23);
   assert(h2.Second() == 46);

   String s3("23-10-2019 23:45:16");
   UTC    u3(s3);

   std::cout << "Contructor from String " << s3 << " : " << u3 << "\n";

   date d3(u3);
   hour h3(u3);

   assert(d3.Day() == 23);
   assert(d3.Month() == 10);
   assert(d3.Year() == 2019);
   assert(h3.Hour() == 23);
   assert(h3.Minute() == 45);
   assert(h3.Second() == 16);

   String s4("Thu Oct  3 22:38:38 CEST 2019");
   UTC    u4(s4);

   std::cout << "Contructor from String " << s4 << " : " << u4 << "\n";

   date d4(u4);
   hour h4(u4);

   assert(d4.Day() == 3);
   assert(d4.Month() == 10);
   assert(d4.Year() == 2019);
   assert(h4.Hour() == 22);
   assert(h4.Minute() == 38);
   assert(h4.Second() == 38);

   return 0;
}

