/*******************************************************
 *  Unit test for the xml class
 *
 * test reading and writing of xml files.
 ******************************************************
 *
 */

#include "xml.h"
#include <assert.h>

int main()
{
   xml    doc;
   String root;
   xml_node root_node;

   doc.ParseFile("xml_test01.xml");
   doc.SaveFile("xml_test01.out.xml");

   root = doc.RootElementName();
   assert (root == "doc");

   root_node = doc.RootNode();
   assert(root_node.is_a_node() == true);
   assert(root_node.name() == "doc");

   doc.ParseFile("notexist.xml");
   root_node = doc.RootNode();
   assert(root_node.is_a_node() == false);
   assert(root_node.name() == "");

   doc.ParseFile("xml_test02.xml");
   root_node = doc.RootNode();
   assert(root_node.is_a_node() == false);
   assert(root_node.name() == "");

   return 0;
}

