/*******************************************************
 *  Unit test for the xml_node class
 *
 * test xml node access
 ******************************************************
 *
 */

#include "xml.h"
#include <assert.h>

int main()
{
   xml    doc;

   const char xml_file[] = "xml_test01.xml";

   std::cout << "Reading XML file " << xml_file << "\n";

   doc.ParseFile("xml_test01.xml");

   xml_node root_node(doc);

   std::cout << "Root element is " << root_node.name() << "\n";
   std::cout << "Root node type is " << root_node.type() << "\n";
   assert(root_node.name() == "doc");

   int i;
   xml_node child;

   root_node = root_node[1]; // The book element
   child = root_node[0];
   for (i = 0; child.is_a_node(); i++)
   {
      child = root_node[i];
      std::cout << "Node " << i << " type is " << child.type() << "\n";
      std::cout << "Node " << i << " name is " << child.name() << "\n";
   }

   return 0;
}

